var width, height, loop, player;
var clsid, file, prefs; 
var menu, player,opensb;

const prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);

window.addEventListener("load", configMenuMSP, false);
prefs1 = prefService.getBranch("extensions.msp.")

function configMenuMSP() {
if (document.getElementById("contentAreaContextMenu")) {
menu = document.getElementById("contentAreaContextMenu");
menu.addEventListener("popupshowing", contextMSP, false);
prefs1.setIntPref("open",0);
}
}

function contextMSP() {
var menuitem = document.getElementById("msp");
if (menuitem) {
menuitem.hidden = !gContextMenu.onLink;
}
}

function openMSP(open) {
href = gContextMenu.linkURL();
prefs1 = prefService.getBranch("extensions.msp.");
prefs1.setCharPref("url", href);
prefs1.setIntPref("open",1);

if (open) {
//toggleSidebar('viewMSP',false);
toggleSidebar('viewMSP',true);
} else {
toggleSidebar('viewMSP',false);
}
}

var myPrefObserver = {
register: function() {
this._branch = prefService.getBranch("extensions.msp.");

var pbi = this._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
pbi.addObserver("", this, false);
},

unregister: function() {
if(!this._branch) return;

var pbi = this._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
pbi.removeObserver("", this);
},

observe: function(aSubject, aTopic, aData) {
if(aTopic != "nsPref:changed") return;
switch (aData) {
case "url":
href = this._branch.getCharPref("url");
player = this._branch.getCharPref("player");

if (player == "wmp") {
document.player.stop();
document.player.fileName = href;
document.player.play();
}

if (player == "real") {
document.player.SetSource(href);
document.player.DoPlay();
}

if (player == "qt") {
document.player.SetURL(href);
document.player.Play();
}
break;
}
}
}

function writeMP() {
myPrefObserver.register();
try {
prefs1 = prefService.getBranch("security.classID.");
} catch (e) {
alert ("The Firefox ActiveX plugin is required for this extension");
return;
}
prefs1.setBoolPref("allowByDefault",true);

prefs1 = prefService.getBranch("extensions.msp.");
opensb = prefs1.getIntPref("open");

width = prefs1.getIntPref("width");
height = prefs1.getIntPref("height");
loop = prefs1.getBoolPref("loop");
player = prefs1.getCharPref("player");

if (opensb == "1") {
href = prefs1.getCharPref("url");
} else {
href = "";
}

if (player == "wmp") {
clsid = "22D6F312-B0F6-11D0-94AB-0080C74C7E95";
}

if (player == "real") {
clsid = "CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA5";
}

if (player == "qt") {
clsid = "02BF25D5-8C17-4B23-BC80-D3488ABDDC6B";
}

var mp = content.document.createElement("object");
mp.setAttribute("id","player");
mp.setAttribute("name","player");
mp.setAttribute("type","application/x-oleobject");
mp.setAttribute("width",width);
mp.setAttribute("height",height);
mp.setAttribute("loop",loop);
mp.setAttribute("classid","CLSID:"+clsid);

if (player == "wmp") {
mp.setAttribute("codebase","http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701");
mp.setAttribute("pluginspage","http://www.microsoft.com/windows/windowsmedia/download/");
var par = content.document.createElement("param");
par.setAttribute("name","AutoStart");
par.setAttribute("value","true");
mp.appendChild(par);
var par1 = content.document.createElement("param");
par1.setAttribute("name","FileName");
par1.setAttribute("value",href);
mp.appendChild(par1);
}

if (player == "real") {
var par = content.document.createElement("param");
par.setAttribute("name","autostart");
par.setAttribute("value","true");
mp.appendChild(par);
var par1 = content.document.createElement("param");
par1.setAttribute("name","src");
par1.setAttribute("value",href);
mp.appendChild(par1);
}

if (player == "qt") {
mp.setAttribute("codebase","http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0");
mp.setAttribute("pluginspage","http://www.apple.com/quicktime/download/index.html");
var par2 = content.document.createElement("param");
par2.setAttribute("name","EnableJavaScript");
par2.setAttribute("value","True");
mp.appendChild(par2);
var par1 = content.document.createElement("param");
par1.setAttribute("name","src");
par1.setAttribute("value",href);
mp.appendChild(par1);
var par = content.document.createElement("param");
par.setAttribute("name","AutoStart");
par.setAttribute("value","True");
mp.appendChild(par);
var par3 = content.document.createElement("param");
par3.setAttribute("name","Controller");
par3.setAttribute("value","True");
mp.appendChild(par3);
}
document.body.appendChild(mp);
}

function unwriteMP() {
myPrefObserver.unregister();
prefs1 = prefService.getBranch("security.classID.");
prefs1.setBoolPref("allowByDefault",false);
prefs1 = prefService.getBranch("extensions.msp.");
prefs1.setIntPref("open",0);
prefs1.setCharPref("url","");
}
